/*
 * The contents of this file are subject to the Netscape Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/NPL/

 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.

 * The Original Code is Rhino code, released
 * May 6, 1999.

 * The Initial Developer of the Original Code is Netscape
 * Communications Corporation.  Portions created by Netscape are
 * Copyright (C) 1997-1999 Netscape Communications Corporation. All
 * Rights Reserved.

 * Contributor(s): 

 * Alternatively, the contents of this file may be used under the
 * terms of the GNU Public License (the "GPL"), in which case the
 * provisions of the GPL are applicable instead of those above.
 * If you wish to allow use of your version of this file only
 * under the terms of the GPL and not to allow others to use your
 * version of this file under the NPL, indicate your decision by
 * deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL.  If you do not delete
 * the provisions above, a recipient may use your version of this
 * file under either the NPL or the GPL.
 */
/* Header file */
#include "js-scriptruntime.h"
#include "js-interpreter.h"
#include "js-interpretedscript.h"

/* Procedures */
void
JSInterpretedScript::init( JSContext *cx )
{
    int size = itsData->itsVariableTable->size();

    namesLength = 0; // gc safe
    names = (jsString_t *) JS_NewGCObj(cx, sizeof (*names) * (size + 1));
    memset(names, 0, sizeof (*names) * (size + 1));
    namesLength = size + 1;
    names[0] = JS_NewGCString(cx, "");
    for (int i = 0; i < size; i++) {
        names[i + 1] = itsData->itsVariableTable->getName(i);
    }
    nestedFunctions = (JSNativeFunction **) itsData->itsNestedFunctions;
    nestedFunctionsLength = itsData->itsNestedFunctionsLength;
    version = (short) cx->getLanguageVersion();
}

jsVal_t
JSInterpretedScript::exec(JSContext *cx, JSScriptable *scope)
{
    return call(cx, scope, scope, 0, NULL);    
}

jsVal_t
JSInterpretedScript::call(JSContext *cx, JSScriptable *scope, 
                   	JSScriptable *thisObj, int numArgs, jsVal_t *args)
{
    scope = JSScriptRuntime::initScript(cx, scope, this, thisObj, 
					itsData->itsFromEvalCode);
#ifdef BRANCH
    JSScript *currentScript = cx->currentScript;

    cx->currentScript = this;

    jsVal_t result
		= JSInterpreter::interpret(cx, scope, thisObj, numArgs, args,
					itsData);
    cx->currentScript = currentScript;
    return result;
#else
    return JSInterpreter::interpret(cx, scope, thisObj, numArgs, args,
				itsData);
#endif
}
void
JSInterpretedScript::mark(JSContext *cx)
{
    JSGCHeap *gcHeap = &cx->runtime->gcHeap;
 
    if (gcHeap->isMarkObj(this)) return;
 
    JSScriptableObject::mark(cx);
    itsData->mark(cx);
}
#ifdef PERSIST
void
JSInterpretedScript::presave( JSContext *cx, JSScriptable *scope,
                JSPersist::StringConstants& stringConstants,
                JSPersist::NumberConstants& numberConstants )
{
    itsData->presave( cx, scope, stringConstants, numberConstants );
}
void
JSInterpretedScript::save( JSContext *cx, JSScriptable *scope,
                JSRandomWriter* out, JSPersist::StringConstants& stringConstants
,
                JSPersist::NumberConstants& numberConstants )
{
    itsData->save( cx, scope, out, stringConstants, numberConstants );
}
void
JSInterpretedScript::load( JSContext *cx, JSScriptable *scope,
                JSRandomReader* in, jsString_t* strings, double* numbers )
{
    itsData->load( cx, scope, in, strings, numbers );

    init( cx );
}
#endif /* PERSIST */

JSInterpretedScript::JSInterpretedScript(JSInterpreterData *theData,
					JSContext *cx)
{
    itsData = theData;

    init( cx );
}

